Index: /LMDZ5/trunk/libf/phylmd/pbl_surface_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/pbl_surface_mod.F90	(revision 2158)
+++ /LMDZ5/trunk/libf/phylmd/pbl_surface_mod.F90	(revision 2159)
@@ -843,12 +1335,62 @@
 
 ! - Calculate the coefficients Ccoef_H, Ccoef_Q, Dcoef_H and Dcoef_Q 
-       CALL climb_hq_down(knon, ycoefh, ypaprs, ypplay, &
+!!! jyg le 07/02/2012
+       IF (iflag_split .eq.0) THEN
+!!!
+!!! nrlmd & jyg les 02/05/2011, 13/06/2011, 05/02/2012
+        CALL climb_hq_down(knon, ycoefh, ypaprs, ypplay, &
             ydelp, yt, yq, dtime, &
+!!! jyg le 09/05/2011
+            CcoefH, CcoefQ, DcoefH, DcoefQ, &
+            Kcoef_hq, gama_q, gama_h, &
+!!!
             AcoefH, AcoefQ, BcoefH, BcoefQ)
+       ELSE  !(iflag_split .eq.0)
+        CALL climb_hq_down(knon, ycoefh_x, ypaprs, ypplay, &
+            ydelp, yt_x, yq_x, dtime, &
+!!! nrlmd le 02/05/2011
+            CcoefH_x, CcoefQ_x, DcoefH_x, DcoefQ_x, &
+            Kcoef_hq_x, gama_q_x, gama_h_x, &
+!!!
+            AcoefH_x, AcoefQ_x, BcoefH_x, BcoefQ_x)
+!
+        CALL climb_hq_down(knon, ycoefh_w, ypaprs, ypplay, &
+            ydelp, yt_w, yq_w, dtime, &
+!!! nrlmd le 02/05/2011
+            CcoefH_w, CcoefQ_w, DcoefH_w, DcoefQ_w, &
+            Kcoef_hq_w, gama_q_w, gama_h_w, &
+!!!
+            AcoefH_w, AcoefQ_w, BcoefH_w, BcoefQ_w)
+!!!
+       ENDIF  ! (iflag_split .eq.0)
+!!!
 
 ! - Calculate the coefficients Ccoef_U, Ccoef_V, Dcoef_U and Dcoef_V
-       CALL climb_wind_down(knon, dtime, ycoefm, ypplay, ypaprs, yt, ydelp, yu, yv, &
+!!! jyg le 07/02/2012
+       IF (iflag_split .eq.0) THEN
+!!! nrlmd & jyg les 02/05/2011, 13/06/2011, 05/02/2012
+        CALL climb_wind_down(knon, dtime, ycoefm, ypplay, ypaprs, yt, ydelp, yu, yv, &
+!!! jyg le 09/05/2011
+            CcoefU, CcoefV, DcoefU, DcoefV, &
+            Kcoef_m, alf_1, alf_2, &
+!!!
             AcoefU, AcoefV, BcoefU, BcoefV)
-      
+       ELSE  ! (iflag_split .eq.0)
+        CALL climb_wind_down(knon, dtime, ycoefm_x, ypplay, ypaprs, yt_x, ydelp, yu_x, yv_x, &
+!!! nrlmd le 02/05/2011
+            CcoefU_x, CcoefV_x, DcoefU_x, DcoefV_x, &
+            Kcoef_m_x, alf_1_x, alf_2_x, &
+!!!
+            AcoefU_x, AcoefV_x, BcoefU_x, BcoefV_x)
+!
+        CALL climb_wind_down(knon, dtime, ycoefm_w, ypplay, ypaprs, yt_w, ydelp, yu_w, yv_w, &
+!!! nrlmd le 02/05/2011
+            CcoefU_w, CcoefV_w, DcoefU_w, DcoefV_w, &
+            Kcoef_m_w, alf_1_w, alf_2_w, &
+!!!
+            AcoefU_w, AcoefV_w, BcoefU_w, BcoefV_w)
+!!!      
+       ENDIF  ! (iflag_split .eq.0)
+!!!
 
 !****************************************************************************************
@@ -870,4 +1412,134 @@
        END IF
 
+!!! nrlmd le 13/06/2011
+!----- On finit le calcul des coefficients d'échange:on multiplie le cdrag par le module du vent et la densité dans la première couche 
+!          Kech_h_x(j) = ycdragh_x(j) * &
+!             (1.0+SQRT(yu_x(j,1)**2+yv_x(j,1)**2)) * &
+!             ypplay(j,1)/(RD*yt_x(j,1))
+!          Kech_h_w(j) = ycdragh_w(j) * &
+!             (1.0+SQRT(yu_w(j,1)**2+yv_w(j,1)**2)) * &
+!             ypplay(j,1)/(RD*yt_w(j,1))
+!          Kech_h(j) = (1.-ywake_s(j))*Kech_h_x(j)+ywake_s(j)*Kech_h_w(j)
+! 
+!          Kech_m_x(j) = ycdragm_x(j) * &
+!             (1.0+SQRT(yu_x(j,1)**2+yv_x(j,1)**2)) * &
+!             ypplay(j,1)/(RD*yt_x(j,1))
+!          Kech_m_w(j) = ycdragm_w(j) * &
+!             (1.0+SQRT(yu_w(j,1)**2+yv_w(j,1)**2)) * &
+!             ypplay(j,1)/(RD*yt_w(j,1))
+!          Kech_m(j) = (1.-ywake_s(j))*Kech_m_x(j)+ywake_s(j)*Kech_m_w(j)
+!!!
+
+!!! nrlmd le 02/05/2011  -----------------------On raccorde les 2 colonnes dans la couche 1 
+!----------------------------------------------------------------------------------------
+!!! jyg le 07/02/2012
+       IF (iflag_split .eq.1) THEN
+!!!
+!!! jyg le 09/04/2013 ; passage aux nouvelles expressions en differences
+
+        DO j=1,knon
+!
+! Calcul des coefficients d echange
+         mod_wind_x = 1.0+SQRT(yu_x(j,1)**2+yv_x(j,1)**2)
+         mod_wind_w = 1.0+SQRT(yu_w(j,1)**2+yv_w(j,1)**2)
+         rho1 = ypplay(j,1)/(RD*yt(j,1))
+         Kech_h_x(j) = ycdragh_x(j) * mod_wind_x * rho1
+         Kech_h_w(j) = ycdragh_w(j) * mod_wind_w * rho1
+         Kech_m_x(j) = ycdragm_x(j) * mod_wind_x * rho1
+         Kech_m_w(j) = ycdragm_w(j) * mod_wind_w * rho1
+!
+         dd_Kh = Kech_h_w(j) - Kech_h_x(j)
+         dd_Km = Kech_m_w(j) - Kech_m_x(j)
+         IF (prt_level >=10) THEN
+          print *,' mod_wind_x, mod_wind_w ', mod_wind_x, mod_wind_w
+          print *,' rho1 ',rho1
+          print *,' ycdragh_x(j),ycdragm_x(j) ',ycdragh_x(j),ycdragm_x(j)
+          print *,' ycdragh_w(j),ycdragm_w(j) ',ycdragh_w(j),ycdragm_w(j)
+          print *,' dd_Kh: ',dd_KH
+         ENDIF
+!
+         Kech_h(j) = Kech_h_x(j) + ywake_s(j)*dd_Kh
+         Kech_m(j) = Kech_m_x(j) + ywake_s(j)*dd_Km
+!
+! Calcul des coefficients d echange corriges des retroactions
+        Kech_H_xp(j) = Kech_h_x(j)/(1.-BcoefH_x(j)*Kech_h_x(j)*dtime)
+        Kech_H_wp(j) = Kech_h_w(j)/(1.-BcoefH_w(j)*Kech_h_w(j)*dtime)
+        Kech_Q_xp(j) = Kech_h_x(j)/(1.-BcoefQ_x(j)*Kech_h_x(j)*dtime)
+        Kech_Q_wp(j) = Kech_h_w(j)/(1.-BcoefQ_w(j)*Kech_h_w(j)*dtime)
+        Kech_U_xp(j) = Kech_m_x(j)/(1.-BcoefU_x(j)*Kech_m_x(j)*dtime)
+        Kech_U_wp(j) = Kech_m_w(j)/(1.-BcoefU_w(j)*Kech_m_w(j)*dtime)
+        Kech_V_xp(j) = Kech_m_x(j)/(1.-BcoefV_x(j)*Kech_m_x(j)*dtime)
+        Kech_V_wp(j) = Kech_m_w(j)/(1.-BcoefV_w(j)*Kech_m_w(j)*dtime)
+!
+         dd_KHp = Kech_H_wp(j) - Kech_H_xp(j)
+         dd_KQp = Kech_Q_wp(j) - Kech_Q_xp(j)
+         dd_KUp = Kech_U_wp(j) - Kech_U_xp(j)
+         dd_KVp = Kech_V_wp(j) - Kech_V_xp(j)
+!
+        Kech_Hp(j) = Kech_H_xp(j) + ywake_s(j)*dd_KHp
+        Kech_Qp(j) = Kech_Q_xp(j) + ywake_s(j)*dd_KQp
+        Kech_Up(j) = Kech_U_xp(j) + ywake_s(j)*dd_KUp
+        Kech_Vp(j) = Kech_V_xp(j) + ywake_s(j)*dd_KVp
+!
+! Calcul des differences w-x
+       dd_CM = ycdragm_w(j) - ycdragm_x(j)
+       dd_CH = ycdragh_w(j) - ycdragh_x(j)
+       dd_u = yu_w(j,1) - yu_x(j,1)
+       dd_v = yv_w(j,1) - yv_x(j,1)
+       dd_t = yt_w(j,1) - yt_x(j,1)
+       dd_q = yq_w(j,1) - yq_x(j,1)
+       dd_AH = AcoefH_w(j) - AcoefH_x(j)
+       dd_AQ = AcoefQ_w(j) - AcoefQ_x(j)
+       dd_AU = AcoefU_w(j) - AcoefU_x(j)
+       dd_AV = AcoefV_w(j) - AcoefV_x(j)
+       dd_BH = BcoefH_w(j) - BcoefH_x(j)
+       dd_BQ = BcoefQ_w(j) - BcoefQ_x(j)
+       dd_BU = BcoefU_w(j) - BcoefU_x(j)
+       dd_BV = BcoefV_w(j) - BcoefV_x(j)
+!
+       IF (prt_level >=10) THEN
+          print *,'Variables pour la fusion : Kech_H_xp(j)' ,Kech_H_xp(j)
+          print *,'Variables pour la fusion : Kech_H_wp(j)' ,Kech_H_wp(j)
+          print *,'Variables pour la fusion : Kech_Hp(j)' ,Kech_Hp(j)
+          print *,'Variables pour la fusion : Kech_h(j)' ,Kech_h(j)
+       ENDIF
+!
+! Calcul des coef A, B équivalents dans la couche 1
+!
+       AcoefH(j) = AcoefH_x(j) + ywake_s(j)*(Kech_H_wp(j)/Kech_Hp(j))*dd_AH
+       AcoefQ(j) = AcoefQ_x(j) + ywake_s(j)*(Kech_Q_wp(j)/Kech_Qp(j))*dd_AQ
+       AcoefU(j) = AcoefU_x(j) + ywake_s(j)*(Kech_U_wp(j)/Kech_Up(j))*dd_AU
+       AcoefV(j) = AcoefV_x(j) + ywake_s(j)*(Kech_V_wp(j)/Kech_Vp(j))*dd_AV
+!
+       BcoefH(j) = BcoefH_x(j) + ywake_s(j)*BcoefH_x(j)*(dd_Kh/Kech_h(j))*(1.+Kech_H_wp(j)/Kech_Hp(j)) &
+                               + ywake_s(j)*(Kech_H_wp(j)/Kech_Hp(j))*(Kech_h_w(j)/Kech_h(j))*dd_BH
+
+       BcoefQ(j) = BcoefQ_x(j) + ywake_s(j)*BcoefQ_x(j)*(dd_Kh/Kech_h(j))*(1.+Kech_Q_wp(j)/Kech_Qp(j)) &
+                               + ywake_s(j)*(Kech_Q_wp(j)/Kech_Qp(j))*(Kech_h_w(j)/Kech_h(j))*dd_BQ
+
+       BcoefU(j) = BcoefU_x(j) + ywake_s(j)*BcoefU_x(j)*(dd_Km/Kech_h(j))*(1.+Kech_U_wp(j)/Kech_Up(j)) &
+                               + ywake_s(j)*(Kech_U_wp(j)/Kech_Up(j))*(Kech_m_w(j)/Kech_m(j))*dd_BU
+
+       BcoefV(j) = BcoefV_x(j) + ywake_s(j)*BcoefV_x(j)*(dd_Km/Kech_h(j))*(1.+Kech_V_wp(j)/Kech_Vp(j)) &
+                               + ywake_s(j)*(Kech_V_wp(j)/Kech_Vp(j))*(Kech_m_w(j)/Kech_m(j))*dd_BV
+
+!
+! Calcul des cdrag équivalents dans la couche 
+!
+       ycdragm(j) = ycdragm_x(j) + ywake_s(j)*dd_CM
+       ycdragh(j) = ycdragh_x(j) + ywake_s(j)*dd_CH
+!
+! Calcul de T, q, u et v équivalents dans la couche 1
+       yt(j,1) = yt_x(j,1) + ywake_s(j)*(Kech_h_w(j)/Kech_h(j))*dd_t
+       yq(j,1) = yq_x(j,1) + ywake_s(j)*(Kech_h_w(j)/Kech_h(j))*dd_q
+       yu(j,1) = yu_x(j,1) + ywake_s(j)*(Kech_m_w(j)/Kech_m(j))*dd_u
+       yv(j,1) = yv_x(j,1) + ywake_s(j)*(Kech_m_w(j)/Kech_m(j))*dd_v
+
+
+        ENDDO
+!!!
+       ENDIF  ! (iflag_split .eq.1)
+!!!
+
 !****************************************************************************************
 !
@@ -893,5 +1565,5 @@
 !****************************************************************************************
 !
-! 10) Switch selon current surface
+! 10) Switch according to current surface
 !     It is necessary to start with the continental surfaces because the ocean
 !     needs their run-off.
@@ -992,4 +1664,19 @@
                ytsurf_new, y_dflux_t, y_dflux_q, slab_wfbils, &
                y_flux_u1, y_flux_v1)
+      IF (prt_level >=10) THEN
+          print *,'arg de surf_ocean: ycdragh ',ycdragh
+          print *,'arg de surf_ocean: ycdragm ',ycdragm
+          print *,'arg de surf_ocean: yt ', yt
+          print *,'arg de surf_ocean: yq ', yq
+          print *,'arg de surf_ocean: yts ', yts
+          print *,'arg de surf_ocean: AcoefH ',AcoefH
+          print *,'arg de surf_ocean: AcoefQ ',AcoefQ
+          print *,'arg de surf_ocean: BcoefH ',BcoefH
+          print *,'arg de surf_ocean: BcoefQ ',BcoefQ
+          print *,'arg de surf_ocean: yevap ',yevap
+          print *,'arg de surf_ocean: yfluxsens ',yfluxsens
+          print *,'arg de surf_ocean: yfluxlat ',yfluxlat
+          print *,'arg de surf_ocean: ytsurf_new ',ytsurf_new
+       ENDIF
           
        CASE(is_sic)
@@ -1036,31 +1723,178 @@
 !
 !****************************************************************************************
-! H and Q
-       IF (ok_flux_surf) THEN
-          PRINT *,'pbl_surface: fsens flat RLVTT=',fsens,flat,RLVTT
+
+!!!
+!!! jyg le 10/04/2013
+!!!
+        IF (ok_flux_surf) THEN
+          IF (prt_level >=10) THEN
+           PRINT *,'pbl_surface: fsens flat RLVTT=',fsens,flat,RLVTT
+          ENDIF
           y_flux_t1(:) =  fsens
           y_flux_q1(:) =  flat/RLVTT
           yfluxlat(:) =  flat
-
-          Kech_h(:) = ycdragh(:) * (1.0+SQRT(yu(:,1)**2+yv(:,1)**2)) * &
-               ypplay(:,1)/(RD*yt(:,1))
-          ytoto(:)=(1./RCPD)*(AcoefH(:)+BcoefH(:)*y_flux_t1(:)*dtime)
-          ytsurf_new(:)=ytoto(:)-y_flux_t1(:)/(Kech_h(:)*RCPD)
+!
+          IF (iflag_split .eq.0) THEN
+             Kech_h(:) = ycdragh(:) * (1.0+SQRT(yu(:,1)**2+yv(:,1)**2)) * &
+                  ypplay(:,1)/(RD*yt(:,1))
+          ENDIF ! (iflag_split .eq.0)
+
+          DO j = 1, knon
+            yt1_new=(1./RCPD)*(AcoefH(j)+BcoefH(j)*yfluxsens(j)*dtime)
+            ytsurf_new(j)=yt1_new-yfluxsens(j)/(Kech_h(j)*RCPD)
+          ENDDO
+
           y_d_ts(:) = ytsurf_new(:) - yts(:) 
 
-       ELSE
+        ELSE ! (ok_flux_surf)
           y_flux_t1(:) =  yfluxsens(:)
           y_flux_q1(:) = -yevap(:)
+        ENDIF
+
+       IF (prt_level >=10) THEN
+        DO j=1,knon
+         print*,'y_flux_t1,yfluxlat,wakes' &
+ &             ,  y_flux_t1(j), yfluxlat(j), ywake_s(j)
+         print*,'beta,ytsurf_new', ybeta(j), ytsurf_new(j)
+         print*,'effusivity,facteur,cstar', effusivity, facteur,wake_cstar(j)
+        ENDDO
        ENDIF
 
-       CALL climb_hq_up(knon, dtime, yt, yq, &
+!!! jyg le 07/02/2012 puis le 10/04/2013
+       IF (iflag_split .eq.1) THEN
+!!!
+        DO j=1,knon
+         y_delta_flux_t1(j) = ( Kech_H_wp(j)*Kech_H_xp(j)*(AcoefH_w(j)-AcoefH_x(j)) + &
+                                y_flux_t1(j)*(Kech_H_wp(j)-Kech_H_xp(j)) ) / Kech_Hp(j)
+         y_delta_flux_q1(j) = ( Kech_Q_wp(j)*Kech_Q_xp(j)*(AcoefQ_w(j)-AcoefQ_x(j)) + &
+                                y_flux_q1(j)*(Kech_Q_wp(j)-Kech_Q_xp(j)) ) / Kech_Qp(j)
+         y_delta_flux_u1(j) = ( Kech_U_wp(j)*Kech_U_xp(j)*(AcoefU_w(j)-AcoefU_x(j)) + &
+                                y_flux_u1(j)*(Kech_U_wp(j)-Kech_U_xp(j)) ) / Kech_Up(j)
+         y_delta_flux_v1(j) = ( Kech_V_wp(j)*Kech_V_xp(j)*(AcoefV_w(j)-AcoefV_x(j)) + &
+                                y_flux_v1(j)*(Kech_V_wp(j)-Kech_V_xp(j)) ) / Kech_Vp(j)
+!
+         y_flux_t1_x(j)=y_flux_t1(j) - ywake_s(j)*y_delta_flux_t1(j)
+         y_flux_t1_w(j)=y_flux_t1(j) + (1.-ywake_s(j))*y_delta_flux_t1(j)
+         y_flux_q1_x(j)=y_flux_q1(j) - ywake_s(j)*y_delta_flux_q1(j)
+         y_flux_q1_w(j)=y_flux_q1(j) + (1.-ywake_s(j))*y_delta_flux_q1(j)
+         y_flux_u1_x(j)=y_flux_u1(j) - ywake_s(j)*y_delta_flux_u1(j)
+         y_flux_u1_w(j)=y_flux_u1(j) + (1.-ywake_s(j))*y_delta_flux_u1(j)
+         y_flux_v1_x(j)=y_flux_v1(j) - ywake_s(j)*y_delta_flux_v1(j)
+         y_flux_v1_w(j)=y_flux_v1(j) + (1.-ywake_s(j))*y_delta_flux_v1(j)
+!
+         yfluxlat_x(j)=y_flux_q1_x(j)*RLVTT
+         yfluxlat_w(j)=y_flux_q1_w(j)*RLVTT
+
+        ENDDO
+!
+ 
+!!jyg!!   A reprendre apres reflexion   ===============================================
+!!jyg!!
+!!jyg!!        DO j=1,knon
+!!jyg!!!!! nrlmd le 13/06/2011
+!!jyg!!
+!!jyg!!!----Diffusion dans le sol dans le cas continental seulement
+!!jyg!!       IF (nsrf.eq.is_ter) THEN
+!!jyg!!!----Calcul du coefficient delta_coeff
+!!jyg!!          tau_eq(j)=(ywake_s(j)/2.)*(1./max(wake_cstar(j),0.01))*sqrt(0.4/(3.14*max(wake_dens(j),8e-12)))
+!!jyg!!
+!!jyg!!!          delta_coef(j)=dtime/(effusivity*sqrt(tau_eq(j)))
+!!jyg!!          delta_coef(j)=facteur*sqrt(tau_eq(j))/effusivity
+!!jyg!!!          delta_coef(j)=0.
+!!jyg!!       ELSE 
+!!jyg!!         delta_coef(j)=0.
+!!jyg!!       ENDIF
+!!jyg!!
+!!jyg!!!----Calcul de delta_tsurf
+!!jyg!!         y_delta_tsurf(j)=delta_coef(j)*y_delta_flux_t1(j)
+!!jyg!!
+!!jyg!!!----Si il n'y a pas des poches...
+!!jyg!!         IF (wake_cstar(j).le.0.01) THEN
+!!jyg!!           y_delta_tsurf(j)=0.
+!!jyg!!           y_delta_flux_t1(j)=0.
+!!jyg!!         ENDIF
+!!jyg!!
+!!jyg!!!-----Calcul de ybeta (evap_réelle/evap_potentielle)
+!!jyg!!!!!!! jyg le 23/02/2012
+!!jyg!!!!!!!
+!!jyg!!!!        ybeta(j)=y_flux_q1(j)   /    &
+!!jyg!!!! &        (Kech_h(j)*(yq(j,1)-yqsatsurf(j)))
+!!jyg!!!!!!        ybeta(j)=-1.*yevap(j)   /    &
+!!jyg!!!!!! &        (ywake_s(j)*Kech_h_w(j)*(yq_w(j,1)-yqsatsurf_w(j))+(1.-ywake_s(j))*Kech_h_x(j)*(yq_x(j,1)-yqsatsurf_x(j)))
+!!jyg!!!!!!! fin jyg
+!!jyg!!!!!
+!!jyg!!
+!!jyg!!       ENDDO
+!!jyg!!
+!!jyg!!!!! fin nrlmd le 13/06/2011
+!!jyg!!
+       IF (prt_level >=10) THEN
+        DO j = 1, knon
+         print*,'Chx,Chw,Ch', ycdragh_x(j), ycdragh_w(j), ycdragh(j)
+         print*,'Khx,Khw,Kh', Kech_h_x(j), Kech_h_w(j), Kech_h(j)
+!         print*,'tsurf_x,tsurf_w,tsurf,t1', ytsurf_th_x(j), ytsurf_th_w(j), ytsurf_th(j), yt(j,1)
+         print*,'tsurf_x,t1x,tsurf_w,t1w,tsurf,t1,t1_ancien', &
+ &               ytsurf_th_x(j), yt_x(j,1), ytsurf_th_w(j), yt_w(j,1), ytsurf_th(j), yt(j,1),t(j,1)
+         print*,'qsatsurf,qsatsurf_x,qsatsurf_w', yqsatsurf(j), yqsatsurf_x(j), yqsatsurf_w(j)
+         print*,'delta_coef,delta_flux,delta_tsurf,tau', delta_coef(j), y_delta_flux_t1(j), y_delta_tsurf(j), tau_eq(j) 
+        ENDDO
+
+        DO j=1,knon
+         print*,'fluxT_x, fluxT_w, y_flux_t1, fluxQ_x, fluxQ_w, yfluxlat, wakes' &
+ &             , y_flux_t1_x(j), y_flux_t1_w(j), y_flux_t1(j), y_flux_q1_x(j)*RLVTT, y_flux_q1_w(j)*RLVTT, yfluxlat(j), ywake_s(j)
+         print*,'beta,ytsurf_new,yqsatsurf', ybeta(j), ytsurf_new(j), yqsatsurf(j)
+         print*,'effusivity,facteur,cstar', effusivity, facteur,wake_cstar(j)
+        ENDDO
+       ENDIF
+
+!!! jyg le 07/02/2012
+       ENDIF  ! (iflag_split .eq.1)
+!!!
+
+!!! jyg le 07/02/2012
+       IF (iflag_split .eq.0) THEN
+!!!
+!!! nrlmd & jyg les 02/05/2011, 13/06/2011, 05/02/2012
+        CALL climb_hq_up(knon, dtime, yt, yq, &
             y_flux_q1, y_flux_t1, ypaprs, ypplay, &
+!!! jyg le 07/02/2012
+            AcoefH, AcoefQ, BcoefH, BcoefQ, &
+            CcoefH, CcoefQ, DcoefH, DcoefQ, &
+            Kcoef_hq, gama_q, gama_h, &
+!!!
             y_flux_q(:,:), y_flux_t(:,:), y_d_q(:,:), y_d_t(:,:))    
-       
-
-       CALL climb_wind_up(knon, dtime, yu, yv, y_flux_u1, y_flux_v1, &
+       ELSE  !(iflag_split .eq.0)
+        CALL climb_hq_up(knon, dtime, yt_x, yq_x, &
+            y_flux_q1_x, y_flux_t1_x, ypaprs, ypplay, &
+!!! nrlmd le 02/05/2011
+            AcoefH_x, AcoefQ_x, BcoefH_x, BcoefQ_x, &
+            CcoefH_x, CcoefQ_x, DcoefH_x, DcoefQ_x, &
+            Kcoef_hq_x, gama_q_x, gama_h_x, &
+!!!
+            y_flux_q_x(:,:), y_flux_t_x(:,:), y_d_q_x(:,:), y_d_t_x(:,:))    
+!
+       CALL climb_hq_up(knon, dtime, yt_w, yq_w, &
+            y_flux_q1_w, y_flux_t1_w, ypaprs, ypplay, &
+!!! nrlmd le 02/05/2011
+            AcoefH_w, AcoefQ_w, BcoefH_w, BcoefQ_w, &
+            CcoefH_w, CcoefQ_w, DcoefH_w, DcoefQ_w, &
+            Kcoef_hq_w, gama_q_w, gama_h_w, &
+!!!
+            y_flux_q_w(:,:), y_flux_t_w(:,:), y_d_q_w(:,:), y_d_t_w(:,:))    
+!!!
+       ENDIF  ! (iflag_split .eq.0)
+!!!
+
+!!! jyg le 07/02/2012
+       IF (iflag_split .eq.0) THEN
+!!!
+!!! nrlmd & jyg les 02/05/2011, 13/06/2011, 05/02/2012
+        CALL climb_wind_up(knon, dtime, yu, yv, y_flux_u1, y_flux_v1, &
+!!! jyg le 07/02/2012
+            AcoefU, AcoefV, BcoefU, BcoefV, &
+            CcoefU, CcoefV, DcoefU, DcoefV, &
+            Kcoef_m, &
+!!!
             y_flux_u, y_flux_v, y_d_u, y_d_v)
-
-
      y_d_t_diss(:,:)=0.
      IF (iflag_pbl>=20 .and. iflag_pbl<30) THEN
@@ -1071,8 +1905,51 @@
 !     print*,'yamada_c OK'
 
-       DO j = 1, knon
+       ELSE  !(iflag_split .eq.0)
+        CALL climb_wind_up(knon, dtime, yu_x, yv_x, y_flux_u1_x, y_flux_v1_x, &
+!!! nrlmd le 02/05/2011
+            AcoefU_x, AcoefV_x, BcoefU_x, BcoefV_x, &
+            CcoefU_x, CcoefV_x, DcoefU_x, DcoefV_x, &
+            Kcoef_m_x, &
+!!!
+            y_flux_u_x, y_flux_v_x, y_d_u_x, y_d_v_x)
+!
+     y_d_t_diss_x(:,:)=0.
+     IF (iflag_pbl>=20 .and. iflag_pbl<30) THEN
+        CALL yamada_c(knon,dtime,ypaprs,ypplay &
+    &   ,yu_x,yv_x,yt_x,y_d_u_x,y_d_v_x,y_d_t_x,ycdragm_x,ytke_x,ycoefm_x,ycoefh_x &
+        ,ycoefq_x,y_d_t_diss_x,yustar_x &
+    &   ,iflag_pbl,nsrf)
+     ENDIF
+!     print*,'yamada_c OK'
+
+        CALL climb_wind_up(knon, dtime, yu_w, yv_w, y_flux_u1_w, y_flux_v1_w, &
+!!! nrlmd le 02/05/2011
+            AcoefU_w, AcoefV_w, BcoefU_w, BcoefV_w, &
+            CcoefU_w, CcoefV_w, DcoefU_w, DcoefV_w, &
+            Kcoef_m_w, &
+!!!
+            y_flux_u_w, y_flux_v_w, y_d_u_w, y_d_v_w)
+!!!
+     y_d_t_diss_w(:,:)=0.
+     IF (iflag_pbl>=20 .and. iflag_pbl<30) THEN
+        CALL yamada_c(knon,dtime,ypaprs,ypplay &
+    &   ,yu_w,yv_w,yt_w,y_d_u_w,y_d_v_w,y_d_t_w,ycdragm_w,ytke_w,ycoefm_w,ycoefh_w &
+        ,ycoefq_w,y_d_t_diss_w,yustar_w &
+    &   ,iflag_pbl,nsrf)
+     ENDIF
+!     print*,'yamada_c OK'
+!
+        IF (prt_level >=10) THEN
+         print *, 'After climbing up, lfuxlat_x, fluxlat_w ', &
+               yfluxlat_x, yfluxlat_w
+        ENDIF
+!
+       ENDIF  ! (iflag_split .eq.0)
+!!!
+
+        DO j = 1, knon
           y_dflux_t(j) = y_dflux_t(j) * ypct(j)
           y_dflux_q(j) = y_dflux_q(j) * ypct(j)
-       ENDDO
+        ENDDO
 
 !****************************************************************************************
@@ -1084,6 +1961,10 @@
 !****************************************************************************************
 
-       DO k = 1, klev
-          DO j = 1, knon
+
+!!! jyg le 07/02/2012
+       IF (iflag_split .eq.0) THEN
+!!!
+        DO k = 1, klev
+           DO j = 1, knon
              i = ni(j)
              y_d_t_diss(j,k)  = y_d_t_diss(j,k) * ypct(j)
@@ -1099,6 +1980,74 @@
 
 
+           ENDDO
+        ENDDO
+
+
+       ELSE  !(iflag_split .eq.0)
+
+! Tendances hors poches
+        DO k = 1, klev
+          DO j = 1, knon
+            i = ni(j)
+            y_d_t_diss_x(j,k)  = y_d_t_diss_x(j,k) * ypct(j)
+            y_d_t_x(j,k)  = y_d_t_x(j,k) * ypct(j)
+            y_d_q_x(j,k)  = y_d_q_x(j,k) * ypct(j)
+            y_d_u_x(j,k)  = y_d_u_x(j,k) * ypct(j)
+            y_d_v_x(j,k)  = y_d_v_x(j,k) * ypct(j)
+
+            flux_t_x(i,k,nsrf) = y_flux_t_x(j,k)
+            flux_q_x(i,k,nsrf) = y_flux_q_x(j,k)
+            flux_u_x(i,k,nsrf) = y_flux_u_x(j,k)
+            flux_v_x(i,k,nsrf) = y_flux_v_x(j,k)
           ENDDO
-       ENDDO
+        ENDDO
+
+! Tendances dans les poches
+        DO k = 1, klev
+          DO j = 1, knon
+            i = ni(j)
+            y_d_t_diss_w(j,k)  = y_d_t_diss_w(j,k) * ypct(j)
+            y_d_t_w(j,k)  = y_d_t_w(j,k) * ypct(j)
+            y_d_q_w(j,k)  = y_d_q_w(j,k) * ypct(j)
+            y_d_u_w(j,k)  = y_d_u_w(j,k) * ypct(j)
+            y_d_v_w(j,k)  = y_d_v_w(j,k) * ypct(j)
+
+            flux_t_w(i,k,nsrf) = y_flux_t_w(j,k)
+            flux_q_w(i,k,nsrf) = y_flux_q_w(j,k)
+            flux_u_w(i,k,nsrf) = y_flux_u_w(j,k)
+            flux_v_w(i,k,nsrf) = y_flux_v_w(j,k)
+          ENDDO
+        ENDDO
+
+! Flux, tendances et Tke moyenne dans la maille
+        DO k = 1, klev
+          DO j = 1, knon
+            i = ni(j)
+            flux_t(i,k,nsrf) = flux_t_x(i,k,nsrf)+ywake_s(j)*(flux_t_w(i,k,nsrf)-flux_t_x(i,k,nsrf))
+            flux_q(i,k,nsrf) = flux_q_x(i,k,nsrf)+ywake_s(j)*(flux_q_w(i,k,nsrf)-flux_q_x(i,k,nsrf))
+            flux_u(i,k,nsrf) = flux_u_x(i,k,nsrf)+ywake_s(j)*(flux_u_w(i,k,nsrf)-flux_u_x(i,k,nsrf))
+            flux_v(i,k,nsrf) = flux_v_x(i,k,nsrf)+ywake_s(j)*(flux_v_w(i,k,nsrf)-flux_v_x(i,k,nsrf))
+          ENDDO
+        ENDDO
+        DO j=1,knon
+          yfluxlat(j)=yfluxlat_x(j)+ywake_s(j)*(yfluxlat_w(j)-yfluxlat_x(j))
+        ENDDO
+        IF (prt_level >=10) THEN
+          print *,' nsrf, flux_t(:,1,nsrf), flux_t_x(:,1,nsrf), flux_t_w(:,1,nsrf) ', &
+                    nsrf, flux_t(:,1,nsrf), flux_t_x(:,1,nsrf), flux_t_w(:,1,nsrf)
+        ENDIF
+
+        DO k = 1, klev
+          DO j = 1, knon
+            y_d_t_diss(j,k) = y_d_t_diss_x(j,k)+ywake_s(j)*(y_d_t_diss_w(j,k) -y_d_t_diss_x(j,k))
+            y_d_t(j,k) = y_d_t_x(j,k)+ywake_s(j)*(y_d_t_w(j,k) -y_d_t_x(j,k))
+            y_d_q(j,k) = y_d_q_x(j,k)+ywake_s(j)*(y_d_q_w(j,k) -y_d_q_x(j,k))
+            y_d_u(j,k) = y_d_u_x(j,k)+ywake_s(j)*(y_d_u_w(j,k) -y_d_u_x(j,k))
+            y_d_v(j,k) = y_d_v_x(j,k)+ywake_s(j)*(y_d_v_w(j,k) -y_d_v_x(j,k))
+          ENDDO
+        ENDDO
+
+       ENDIF  ! (iflag_split .eq.0)
+!!!
 
 !      print*,'Dans pbl OK1'
@@ -1130,11 +2079,74 @@
 !      print*,'Dans pbl OK2'
 
+!!! jyg le 07/02/2012
+       IF (iflag_split .eq.1) THEN
+!!!
+!!! nrlmd le 02/05/2011
+        fluxlat_x(:,nsrf) = 0.
+        fluxlat_w(:,nsrf) = 0.
+        DO j = 1, knon
+          i = ni(j)
+          fluxlat_x(i,nsrf) = yfluxlat_x(j)
+          fluxlat_w(i,nsrf) = yfluxlat_w(j)
+!!!
+!!! nrlmd le 13/06/2011
+          delta_tsurf(i,nsrf)=y_delta_tsurf(j)*ypct(j)
+          cdragh_x(i) = cdragh_x(i) + ycdragh_x(j)*ypct(j)
+          cdragh_w(i) = cdragh_w(i) + ycdragh_w(j)*ypct(j)
+          cdragm_x(i) = cdragm_x(i) + ycdragm_x(j)*ypct(j)
+          cdragm_w(i) = cdragm_w(i) + ycdragm_w(j)*ypct(j)
+          kh(i) = kh(i) + Kech_h(j)*ypct(j)
+          kh_x(i) = kh_x(i) + Kech_h_x(j)*ypct(j)
+          kh_w(i) = kh_w(i) + Kech_h_w(j)*ypct(j)
+!!!
+        END DO
+!!!      
+       ENDIF  ! (iflag_split .eq.1)
+!!!
+!!! nrlmd le 02/05/2011
+!!jyg le 20/02/2011
+!!        tke_x(:,:,nsrf)=0.
+!!        tke_w(:,:,nsrf)=0.
+!!jyg le 20/02/2011
+!!        DO k = 1, klev+1
+!!          DO j = 1, knon
+!!            i = ni(j)
+!!            wake_dltke(i,k,nsrf) = ytke_w(j,k) - ytke_x(j,k)
+!!            tke(i,k,nsrf)   = ytke_x(j,k) + ywake_s(j)*wake_dltke(i,k,nsrf)
+!!          ENDDO
+!!        ENDDO
+!!jyg le 20/02/2011
+!!        DO k = 1, klev+1
+!!          DO j = 1, knon
+!!            i = ni(j)
+!!            tke(i,k,nsrf)=(1.-ywake_s(j))*tke_x(i,k,nsrf)+ywake_s(j)*tke_w(i,k,nsrf)
+!!          ENDDO
+!!        ENDDO
+!!!
+       IF (iflag_split .eq.0) THEN
+        DO k = 2, klev
+           DO j = 1, knon
+              i = ni(j)
+              tke(i,k,nsrf)    = ytke(j,k)
+              tke(i,k,is_ave) = tke(i,k,is_ave) + ytke(j,k)*ypct(j)
+           END DO
+        END DO
+
+       ELSE
+        DO k = 2, klev
+          DO j = 1, knon
+            i = ni(j)
+            wake_dltke(i,k,nsrf) = ytke_w(j,k) - ytke_x(j,k)
+            tke(i,k,nsrf)   = ytke_x(j,k) + ywake_s(j)*wake_dltke(i,k,nsrf)
+            tke(i,k,is_ave) = tke(i,k,is_ave) + tke(i,k,nsrf)*ypct(j)
+          ENDDO
+        ENDDO
+       ENDIF  ! (iflag_split .eq.0)
+!!!
        DO k = 2, klev
           DO j = 1, knon
              i = ni(j)
-             tke(i,k,nsrf)    = ytke(j,k)
              zcoefh(i,k,nsrf) = ycoefh(j,k)
              zcoefm(i,k,nsrf) = ycoefm(j,k)
-             tke(i,k,is_ave) = tke(i,k,is_ave) + ytke(j,k)*ypct(j)
              zcoefh(i,k,is_ave) = zcoefh(i,k,is_ave) + ycoefh(j,k)*ypct(j)
              zcoefm(i,k,is_ave) = zcoefm(i,k,is_ave) + ycoefm(j,k)*ypct(j)
@@ -1159,4 +2171,30 @@
        END DO
        
+!!! jyg le 07/02/2012
+       IF (iflag_split .eq.1) THEN
+!!!
+!!! nrlmd+jyg le 02/05/2011 et le 20/02/2012
+        DO k = 1, klev
+          DO j = 1, knon
+           i = ni(j)
+           d_t_diss_x(i,k) = d_t_diss_x(i,k) + y_d_t_diss_x(j,k)
+           d_t_x(i,k) = d_t_x(i,k) + y_d_t_x(j,k)
+           d_q_x(i,k) = d_q_x(i,k) + y_d_q_x(j,k)
+           d_u_x(i,k) = d_u_x(i,k) + y_d_u_x(j,k)
+           d_v_x(i,k) = d_v_x(i,k) + y_d_v_x(j,k)
+!
+           d_t_diss_w(i,k) = d_t_diss_w(i,k) + y_d_t_diss_w(j,k)
+           d_t_w(i,k) = d_t_w(i,k) + y_d_t_w(j,k)
+           d_q_w(i,k) = d_q_w(i,k) + y_d_q_w(j,k)
+           d_u_w(i,k) = d_u_w(i,k) + y_d_u_w(j,k)
+           d_v_w(i,k) = d_v_w(i,k) + y_d_v_w(j,k)
+!
+!!           d_wake_dlt(i,k) = d_wake_dlt(i,k) + y_d_t_w(i,k)-y_d_t_x(i,k)
+!!           d_wake_dlq(i,k) = d_wake_dlq(i,k) + y_d_q_w(i,k)-y_d_q_x(i,k)
+          END DO
+        END DO
+!!!
+       ENDIF  ! (iflag_split .eq.1)
+!!!
        
        DO k = 1, klev
@@ -1173,6 +2211,11 @@
 !      print*,'Dans pbl OK4'
 
-!****************************************************************************************
-! 14) Calculate the temperature et relative humidity at 2m and the wind at 10m 
+       IF (prt_level >=10) THEN
+         print *, 'pbl_surface tendencies for w: d_t_w, d_t_x, d_t ', &
+          d_t_w(:,1), d_t_x(:,1), d_t(:,1)
+       ENDIF
+
+!****************************************************************************************
+! 14) Calculate the temperature and relative humidity at 2m and the wind at 10m 
 !     Call HBTM
 !
@@ -1184,4 +2227,5 @@
        u10m(:,nsrf)   = 0.
        v10m(:,nsrf)   = 0.
+
        pblh(:,nsrf)   = 0.        ! Hauteur de couche limite
        plcl(:,nsrf)   = 0.        ! Niveau de condensation de la CLA
@@ -1194,5 +2238,46 @@
        trmb2(:,nsrf)  = 0.        ! inhibition 
        trmb3(:,nsrf)  = 0.        ! Point Omega
-
+!
+!!! jyg le 07/02/2012
+       IF (iflag_split .eq.1) THEN
+       t2m_x(:,nsrf)    = 0. 
+       q2m_x(:,nsrf)    = 0. 
+       ustar_x(:,nsrf)   = 0.
+       wstar_x(:,nsrf)   = 0.
+       u10m_x(:,nsrf)   = 0. 
+       v10m_x(:,nsrf)   = 0. 
+                           
+       pblh_x(:,nsrf)   = 0.      ! Hauteur de couche limite
+       plcl_x(:,nsrf)   = 0.      ! Niveau de condensation de la CLA
+       capCL_x(:,nsrf)  = 0.      ! CAPE de couche limite
+       oliqCL_x(:,nsrf) = 0.      ! eau_liqu integree de couche limite
+       cteiCL_x(:,nsrf) = 0.      ! cloud top instab. crit. couche limite
+       pblt_x(:,nsrf)   = 0.      ! T a la Hauteur de couche limite
+       therm_x(:,nsrf)  = 0.      
+       trmb1_x(:,nsrf)  = 0.      ! deep_cape
+       trmb2_x(:,nsrf)  = 0.      ! inhibition 
+       trmb3_x(:,nsrf)  = 0.      ! Point Omega
+!
+       t2m_w(:,nsrf)    = 0. 
+       q2m_w(:,nsrf)    = 0. 
+       ustar_w(:,nsrf)   = 0.
+       wstar_w(:,nsrf)   = 0.
+       u10m_w(:,nsrf)   = 0. 
+       v10m_w(:,nsrf)   = 0. 
+                           
+       pblh_w(:,nsrf)   = 0.      ! Hauteur de couche limite
+       plcl_w(:,nsrf)   = 0.      ! Niveau de condensation de la CLA
+       capCL_w(:,nsrf)  = 0.      ! CAPE de couche limite
+       oliqCL_w(:,nsrf) = 0.      ! eau_liqu integree de couche limite
+       cteiCL_w(:,nsrf) = 0.      ! cloud top instab. crit. couche limite
+       pblt_w(:,nsrf)   = 0.      ! T a la Hauteur de couche limite
+       therm_w(:,nsrf)  = 0.      
+       trmb1_w(:,nsrf)  = 0.      ! deep_cape
+       trmb2_w(:,nsrf)  = 0.      ! inhibition 
+       trmb3_w(:,nsrf)  = 0.      ! Point Omega
+!!!      
+       ENDIF  ! (iflag_split .eq.1)
+!!!
+!
 #undef T2m     
 #define T2m     
@@ -1203,6 +2288,7 @@
 !      print*,'tair1,yt(:,1),y_d_t(:,1)'
 !      print*, tair1,yt(:,1),y_d_t(:,1)
-       DO j=1, knon
-          i = ni(j)
+!!! jyg le 07/02/2012
+       IF (iflag_split .eq.0) THEN
+        DO j=1, knon
           uzon(j) = yu(j,1) + y_d_u(j,1)
           vmer(j) = yv(j,1) + y_d_v(j,1)
@@ -1212,4 +2298,33 @@
                * (ypaprs(j,1)-ypplay(j,1))
           tairsol(j) = yts(j) + y_d_ts(j)
+          qairsol(j) = yqsurf(j)
+        END DO
+       ELSE  ! (iflag_split .eq.0)
+        DO j=1, knon
+          uzon_x(j) = yu_x(j,1) + y_d_u_x(j,1)
+          vmer_x(j) = yv_x(j,1) + y_d_v_x(j,1)
+          tair1_x(j) = yt_x(j,1) + y_d_t_x(j,1) + y_d_t_diss_x(j,1)
+          qair1_x(j) = yq_x(j,1) + y_d_q_x(j,1)
+          zgeo1_x(j) = RD * tair1_x(j) / (0.5*(ypaprs(j,1)+ypplay(j,1))) &
+               * (ypaprs(j,1)-ypplay(j,1))
+          tairsol(j) = yts(j) + y_d_ts(j)
+          tairsol_x(j) = tairsol(j) - ywake_s(j)*y_delta_tsurf(j)
+          qairsol(j) = yqsurf(j)
+        END DO
+        DO j=1, knon
+          uzon_w(j) = yu_w(j,1) + y_d_u_w(j,1)
+          vmer_w(j) = yv_w(j,1) + y_d_v_w(j,1)
+          tair1_w(j) = yt_w(j,1) + y_d_t_w(j,1) + y_d_t_diss_w(j,1)
+          qair1_w(j) = yq_w(j,1) + y_d_q_w(j,1)
+          zgeo1_w(j) = RD * tair1_w(j) / (0.5*(ypaprs(j,1)+ypplay(j,1))) &
+               * (ypaprs(j,1)-ypplay(j,1))
+          tairsol_w(j) = tairsol(j) + (1.- ywake_s(j))*y_delta_tsurf(j)
+          qairsol(j) = yqsurf(j)
+        END DO
+!!!      
+       ENDIF  ! (iflag_split .eq.0)
+!!!
+       DO j=1, knon
+          i = ni(j)
           rugo1(j) = yrugos(j)
           IF(nsrf.EQ.is_oce) THEN
@@ -1218,5 +2333,4 @@
           psfce(j)=ypaprs(j,1)
           patm(j)=ypplay(j,1)
-          qairsol(j) = yqsurf(j)
        END DO
        
